﻿using System;
using System.Drawing;

namespace SummerGUI
{	
	public static class NcsColors
	{
		public static readonly Color White = Color.FromArgb(255, 255, 255);
		public static readonly Color Black = Color.FromArgb(0, 0, 0);
		public static readonly Color Green = Color.FromArgb(0, 159, 107);
		public static readonly Color Red = Color.FromArgb(196,2,51);
		public static readonly Color Yellow = Color.FromArgb(255, 211, 0);
		public static readonly Color Blue = Color.FromArgb(0, 135, 189);
	}

	public static class FashionColors
	{
		public static readonly Color Cerulean = Color.FromArgb(155, 183, 212);
		public static readonly Color FuchsiaRose = Color.FromArgb(199, 67, 117);
		public static readonly Color TrueRed = Color.FromArgb(191, 25, 50);
		public static readonly Color AquaSky = Color.FromArgb(123, 196, 196);
		public static readonly Color Tigerlily = Color.FromArgb(226, 88, 62);
		public static readonly Color BlueTurquoise = Color.FromArgb(83, 176, 174);

		public static readonly Color SandDollar = Color.FromArgb(222, 205, 190);
		public static readonly Color ChiliPepper = Color.FromArgb(155, 27, 48);
		public static readonly Color BlueIris = Color.FromArgb(90, 91, 159);
		public static readonly Color Mimosa = Color.FromArgb(240, 192, 90);
		public static readonly Color Turquoise = Color.FromArgb(69, 181, 170);
		public static readonly Color Honeysuckle = Color.FromArgb(217, 79, 112);

		public static readonly Color TangerineTango = Color.FromArgb(221, 65, 36);
		public static readonly Color Emerald = Color.FromArgb(0, 148, 115);
		public static readonly Color RadiantOrchid = Color.FromArgb(177, 99, 163);
		public static readonly Color Marsala = Color.FromArgb(149, 82, 81);
	}

	public static class ColorCheckerColors
	{
		// Row 1: Natural colors
		public static readonly Color DarkSkin = Color.FromArgb(115, 82, 68);
		public static readonly Color LightSkin = Color.FromArgb(194, 150, 130);
		public static readonly Color BlueSky = Color.FromArgb(98, 122, 157);
		public static readonly Color Foliage = Color.FromArgb(87, 108, 67);
		public static readonly Color BlueFlower = Color.FromArgb(133, 128, 177);
		public static readonly Color BluishGreen = Color.FromArgb(103, 189, 170);

		// Row 2: Miscellaneous colors
		public static readonly Color Orange = Color.FromArgb(214, 126, 44);
		public static readonly Color PurplishBlue = Color.FromArgb(80, 91, 166);
		public static readonly Color ModerateRed = Color.FromArgb(193, 90, 99);
		public static readonly Color Purple = Color.FromArgb(94, 60, 108);
		public static readonly Color YellowGreen = Color.FromArgb(157, 188, 64);
		public static readonly Color OrangeYellow = Color.FromArgb(224, 163, 46);

		// Row 3: Primary and secondary colors
		public static readonly Color Blue = Color.FromArgb(56, 61, 150);
		public static readonly Color Green = Color.FromArgb(70, 148, 73);
		public static readonly Color Red = Color.FromArgb(175, 54, 60);
		public static readonly Color Yellow = Color.FromArgb(231, 199, 31);
		public static readonly Color Magenta = Color.FromArgb(187, 86, 149);
		public static readonly Color Cyan = Color.FromArgb(8, 133, 161);

		// Row 4: Grayscale colors
		public static readonly Color White = Color.FromArgb(243, 243, 242);
		public static readonly Color Neutral8 = Color.FromArgb(200, 200, 200);
		public static readonly Color Neutral65 = Color.FromArgb(160, 160, 160);
		public static readonly Color Neutral5 = Color.FromArgb(122, 122, 121);
		public static readonly Color Neutral35 = Color.FromArgb(85, 85, 85);
		public static readonly Color Black = Color.FromArgb(52, 52, 52);
	}


	public static class RandomColors
	{
		public static readonly Color Blue = Color.FromArgb(0, 0, 255);
		public static readonly Color Red = Color.FromArgb(255, 0, 0);
		public static readonly Color Green = Color.FromArgb(0, 128, 0);
		public static readonly Color Orange = Color.FromArgb(255, 165, 0);
		public static readonly Color Violet = Color.FromArgb(238, 130, 238);
		public static readonly Color DarkCyan = Color.FromArgb(0, 139, 139);
		public static readonly Color Magenta = Color.FromArgb(255, 0, 255);
		public static readonly Color Indigo = Color.FromArgb(75, 0, 130);
		public static readonly Color Crimson = Color.FromArgb(220, 20, 60);
		public static readonly Color CornflowerBlue = Color.FromArgb(100, 149, 237);
		public static readonly Color DarkRed = Color.FromArgb(139, 0, 0);
		public static readonly Color Fuchsia = Color.FromArgb(255, 0, 255);
		public static readonly Color Tomato = Color.FromArgb(255, 99, 71);
		public static readonly Color DarkGoldenrod = Color.FromArgb(184, 134, 11);
		public static readonly Color Teal = Color.FromArgb(0, 128, 128);
		public static readonly Color DarkOrchid = Color.FromArgb(153, 50, 204);
		public static readonly Color DarkViolet = Color.FromArgb(148, 0, 211);
		public static readonly Color Firebrick = Color.FromArgb(178, 34, 34);
		public static readonly Color DarkBlue = Color.FromArgb(0, 0, 139);
		public static readonly Color DeepPink = Color.FromArgb(255, 20, 147);
		public static readonly Color DarkMagenta = Color.FromArgb(139, 0, 139);
		public static readonly Color SteelBlue = Color.FromArgb(70, 130, 180);
		public static readonly Color DarkOliveGreen = Color.FromArgb(85, 107, 47);
		public static readonly Color CadetBlue = Color.FromArgb(95, 158, 160);
		public static readonly Color DarkSlateGray = Color.FromArgb(47, 79, 79);
	}

	public static class RandomCoatedColors
	{
		public static readonly Color Blue = Color.FromArgb(74, 37, 170);
		public static readonly Color Red = Color.FromArgb(235, 51, 0);
		public static readonly Color Green = Color.FromArgb(0, 133, 34);
		public static readonly Color Orange = Color.FromArgb(242, 169, 0);
		public static readonly Color Violet = Color.FromArgb(221, 127, 211);
		public static readonly Color DarkCyan = Color.FromArgb(0, 150, 143);
		public static readonly Color Magenta = Color.FromArgb(234, 39, 194);
		public static readonly Color Indigo = Color.FromArgb(78, 0, 142);
		public static readonly Color Crimson = Color.FromArgb(213, 0, 50);
		public static readonly Color CornflowerBlue = Color.FromArgb(122, 147, 220);
		public static readonly Color DarkRed = Color.FromArgb(138, 42, 43);
		public static readonly Color Fuchsia = Color.FromArgb(234, 39, 194);
		public static readonly Color Tomato = Color.FromArgb(229, 106, 84);
		public static readonly Color DarkGoldenrod = Color.FromArgb(172, 132, 0);
		public static readonly Color Teal = Color.FromArgb(5, 134, 142);
		public static readonly Color DarkOrchid = Color.FromArgb(150, 60, 189);
		public static readonly Color DarkViolet = Color.FromArgb(155, 38, 182);
		public static readonly Color Firebrick = Color.FromArgb(167, 43, 42);
		public static readonly Color DarkBlue = Color.FromArgb(46, 0, 139);
		public static readonly Color DeepPink = Color.FromArgb(230, 56, 136);
		public static readonly Color DarkMagenta = Color.FromArgb(143, 26, 149);
		public static readonly Color SteelBlue = Color.FromArgb(92, 130, 165);
		public static readonly Color DarkOliveGreen = Color.FromArgb(74, 106, 29);
		public static readonly Color CadetBlue = Color.FromArgb(79, 159, 166);
		public static readonly Color DarkSlateGray = Color.FromArgb(62, 93, 88);
	}

	public static class RandomUncoatedColors
	{
		public static readonly Color Blue = Color.FromArgb(63, 67, 173);
		public static readonly Color Red = Color.FromArgb(240, 81, 54);
		public static readonly Color Green = Color.FromArgb(70, 146, 83);
		public static readonly Color Orange = Color.FromArgb(238, 157, 38);
		public static readonly Color Violet = Color.FromArgb(224, 127, 208);
		public static readonly Color DarkCyan = Color.FromArgb(62, 142, 139);
		public static readonly Color Magenta = Color.FromArgb(232, 56, 191);
		public static readonly Color Indigo = Color.FromArgb(101, 66, 138);
		public static readonly Color Crimson = Color.FromArgb(203, 79, 83);
		public static readonly Color CornflowerBlue = Color.FromArgb(119, 139, 217);
		public static readonly Color DarkRed = Color.FromArgb(160, 91, 78);
		public static readonly Color Fuchsia = Color.FromArgb(232, 56, 191);
		public static readonly Color Tomato = Color.FromArgb(254, 84, 66);
		public static readonly Color DarkGoldenrod = Color.FromArgb(183, 140, 48);
		public static readonly Color Teal = Color.FromArgb(19, 125, 121);
		public static readonly Color DarkOrchid = Color.FromArgb(151, 87, 166);
		public static readonly Color DarkViolet = Color.FromArgb(148, 75, 150);
		public static readonly Color Firebrick = Color.FromArgb(180, 88, 88);
		public static readonly Color DarkBlue = Color.FromArgb(63, 67, 173);
		public static readonly Color DeepPink = Color.FromArgb(228, 76, 154);
		public static readonly Color DarkMagenta = Color.FromArgb(148, 75, 150);
		public static readonly Color SteelBlue = Color.FromArgb(78, 123, 189);
		public static readonly Color DarkOliveGreen = Color.FromArgb(91, 121, 78);
		public static readonly Color CadetBlue = Color.FromArgb(96, 156, 162);
		public static readonly Color DarkSlateGray = Color.FromArgb(69, 93, 88);
	}

	public static class RandomMetallicColors
	{
		public static readonly Color Blue = Color.FromArgb(88, 73, 144);
		public static readonly Color Red = Color.FromArgb(183, 78, 35);
		public static readonly Color Green = Color.FromArgb(67, 130, 64);
		public static readonly Color Orange = Color.FromArgb(172, 139, 26);
		public static readonly Color Violet = Color.FromArgb(153, 106, 144);
		public static readonly Color DarkCyan = Color.FromArgb(51, 132, 144);
		public static readonly Color Magenta = Color.FromArgb(154, 93, 139);
		public static readonly Color Indigo = Color.FromArgb(78, 43, 96);
		public static readonly Color Crimson = Color.FromArgb(187, 79, 81);
		public static readonly Color CornflowerBlue = Color.FromArgb(109, 136, 154);
		public static readonly Color DarkRed = Color.FromArgb(112, 67, 60);
		public static readonly Color Fuchsia = Color.FromArgb(154, 93, 139);
		public static readonly Color Tomato = Color.FromArgb(182, 91, 73);
		public static readonly Color DarkGoldenrod = Color.FromArgb(172, 135, 0);
		public static readonly Color Teal = Color.FromArgb(33, 121, 124);
		public static readonly Color DarkOrchid = Color.FromArgb(113, 80, 150);
		public static readonly Color DarkViolet = Color.FromArgb(113, 80, 150);
		public static readonly Color Firebrick = Color.FromArgb(173, 83, 69);
		public static readonly Color DarkBlue = Color.FromArgb(58, 60, 123);
		public static readonly Color DeepPink = Color.FromArgb(179, 95, 107);
		public static readonly Color DarkMagenta = Color.FromArgb(132, 48, 114);
		public static readonly Color SteelBlue = Color.FromArgb(94, 120, 156);
		public static readonly Color DarkOliveGreen = Color.FromArgb(106, 123, 70);
		public static readonly Color CadetBlue = Color.FromArgb(96, 154, 148);
		public static readonly Color DarkSlateGray = Color.FromArgb(60, 76, 74);
	}

	public static class RandomNeonColors
	{
		public static readonly Color Blue = Color.FromArgb(138, 105, 212);
		public static readonly Color Red = Color.FromArgb(255, 114, 118);
		public static readonly Color Green = Color.FromArgb(0, 128, 0);	// not set
		public static readonly Color Orange = Color.FromArgb(255, 214, 53);
		public static readonly Color Violet = Color.FromArgb(245, 127, 224);
		public static readonly Color DarkCyan = Color.FromArgb(0, 154, 206);
		public static readonly Color Magenta = Color.FromArgb(234, 39, 194);
		public static readonly Color Indigo = Color.FromArgb(75, 0, 130);	// not set
		public static readonly Color Crimson = Color.FromArgb(255, 114, 118);
		public static readonly Color CornflowerBlue = Color.FromArgb(153, 122, 219);
		public static readonly Color DarkRed = Color.FromArgb(139, 0, 0);	// not set
		public static readonly Color Fuchsia = Color.FromArgb(234, 39, 194);
		public static readonly Color Tomato = Color.FromArgb(255, 114, 118);
		public static readonly Color DarkGoldenrod = Color.FromArgb(158, 151, 142);	// wrong
		public static readonly Color Teal = Color.FromArgb(0, 154, 206);
		public static readonly Color DarkOrchid = Color.FromArgb(138, 105, 212);
		public static readonly Color DarkViolet = Color.FromArgb(138, 105, 212);
		public static readonly Color Firebrick = Color.FromArgb(178, 34, 34); // not set
		public static readonly Color DarkBlue = Color.FromArgb(0, 0, 139);	// not set
		public static readonly Color DeepPink = Color.FromArgb(255, 62, 181);
		public static readonly Color DarkMagenta = Color.FromArgb(234, 39, 194);
		public static readonly Color SteelBlue = Color.FromArgb(138, 105, 212);
		public static readonly Color DarkOliveGreen = Color.FromArgb(85, 107, 47);	// not set
		public static readonly Color CadetBlue = Color.FromArgb(0, 188, 227);
		public static readonly Color DarkSlateGray = Color.FromArgb(47, 79, 79);	// not set
	}

	public static class RandomRalColors
	{
		public static readonly Color Blue = Color.FromArgb(43, 58, 68);
		public static readonly Color Red = Color.FromArgb(255, 45, 33);
		public static readonly Color Green = Color.FromArgb(0, 139, 41);
		public static readonly Color Orange = Color.FromArgb(249, 168, 0);
		public static readonly Color Violet = Color.FromArgb(152, 158, 161);
		public static readonly Color DarkCyan = Color.FromArgb(5, 139, 140);
		public static readonly Color Magenta = Color.FromArgb(122, 136, 142);
		public static readonly Color Indigo = Color.FromArgb(43, 58, 68);
		public static readonly Color Crimson = Color.FromArgb(199, 63, 74);
		public static readonly Color CornflowerBlue = Color.FromArgb(96, 147, 172);
		public static readonly Color DarkRed = Color.FromArgb(155, 35, 33);
		public static readonly Color Fuchsia = Color.FromArgb(122, 136, 142);
		public static readonly Color Tomato = Color.FromArgb(255, 45, 33);
		public static readonly Color DarkGoldenrod = Color.FromArgb(167, 127, 14);
		public static readonly Color Teal = Color.FromArgb(5, 139, 140);
		public static readonly Color DarkOrchid = Color.FromArgb(91, 104, 109);
		public static readonly Color DarkViolet = Color.FromArgb(91, 104, 109);
		public static readonly Color Firebrick = Color.FromArgb(167, 41, 32);
		public static readonly Color DarkBlue = Color.FromArgb(43, 58, 68);
		public static readonly Color DeepPink = Color.FromArgb(196, 97, 140);
		public static readonly Color DarkMagenta = Color.FromArgb(144, 51, 115);
		public static readonly Color SteelBlue = Color.FromArgb(99, 125, 150);
		public static readonly Color DarkOliveGreen = Color.FromArgb(94, 110, 59);
		public static readonly Color CadetBlue = Color.FromArgb(122, 172, 172);
		public static readonly Color DarkSlateGray = Color.FromArgb(2, 68, 66);
	}		
}

